package u6a4;

import java.util.EmptyStackException;

public class ChunkedStack implements u6a2.IStack {
	/**
	 * Linked list of chunks
	 */
	private ChunkList chunks;
	
	/**
	 * the number of slots of the last chunk which are used. 
	 */
	private int used;
	
	public String toString()
	{
		if (empty()) return "[]";
		
		StringBuffer buf = new StringBuffer("[");
		ChunkList last = chunks.last();
		for (ChunkList iter = last; iter != null; iter = chunks.predecessor(iter))
		{
			int size;
			if (iter == last) {
				size = used;
			} else {
				size = ChunkList.chunkSize;
			}
			
			for (int i=size; i>0; i--) {
				buf.append(iter.buffer[i-1]).append(", ");
			}
		}
		buf.delete(buf.length()-2, buf.length());
		buf.append("]");
		return buf.toString();
	}
	
	public ChunkedStack()
	{
		chunks = new ChunkList();
		used = 0;
	}

	public boolean empty() 
	{
	}

	public int peek() throws EmptyStackException 
	{
	}

	public int pop() throws EmptyStackException 
	{
	}

	public void push(int number) 
	{
	}

	public int size() 
	{
	}
}
